echo off
echo ** GuruCE Patch 3.0 QT5.6.Beta**
set PATCH_EXTENTION=.guruce

REM enable or disable individual patches (could be that some of these patches a are fixed in future releases
set DIRECTSHOW_PATCH_EN=1
set CE_COMPAT_PATCH_EN=1
set ZLIB_INC_PATCH_EN=
set VS2015_SUPPORT_PATCH=1
set MKSPEC_COPY_EN=1
set QWINDOWS_INTEGRATION_PATCH=1
set QUICKCONTROLS_TEXTEDITOR_PATCH=1
set DBUS_PATCH_EN=1

if '%1'=='' (echo pass parameter -u to Undo the patches)

REM DirectShow patch (replace main.cpp files with ours and rename the file to PATCH_EXTENTION)
set DIRECT_SHOW_PATH=..\qtmultimedia\config.tests\directshow\
set DIRECT_SHOW_FILE=main.cpp
if '%DIRECTSHOW_PATCH_EN%'=='1' (
   echo directshow patch enabled
   if '%1'=='-u' (
      echo undo directshow patch
      if exist "%DIRECT_SHOW_PATH%%DIRECT_SHOW_FILE%%PATCH_EXTENTION%" (
         del %DIRECT_SHOW_PATH%%DIRECT_SHOW_FILE%
         rename %DIRECT_SHOW_PATH%%DIRECT_SHOW_FILE%%PATCH_EXTENTION% %DIRECT_SHOW_FILE%
      )
   ) else (
      echo applying directshow patch
      rename %DIRECT_SHOW_PATH%%DIRECT_SHOW_FILE% %DIRECT_SHOW_FILE%%PATCH_EXTENTION%
      copy directshow_test_main.cpp %DIRECT_SHOW_PATH%%DIRECT_SHOW_FILE%
   )
)

REM QTScript ce_compat patch (replace ce_compat files with ours and rename the folder to PATCH_EXTENTION)
REM QTBUG-49479
set CE_COMPAT_PATH=..\qtscript\src\3rdparty\
set CE_COMPAT_FOLDER=ce-compat
if '%CE_COMPAT_PATCH_EN%'=='1' (
   if '%1'=='-u' (
      echo undo ce-compat patch
      if exist "%CE_COMPAT_PATH%%CE_COMPAT_FOLDER%%PATCH_EXTENTION%" (
        rmdir /S /Q %CE_COMPAT_PATH%%CE_COMPAT_FOLDER%
        rename %CE_COMPAT_PATH%%CE_COMPAT_FOLDER%%PATCH_EXTENTION% %CE_COMPAT_FOLDER%
      )
   ) else (
      echo applying ce_compat patch
      rename %CE_COMPAT_PATH%%CE_COMPAT_FOLDER% %CE_COMPAT_FOLDER%%PATCH_EXTENTION%
      xcopy /I /Y %CE_COMPAT_FOLDER% %CE_COMPAT_PATH%%CE_COMPAT_FOLDER%
   )
)     

REM zlib.h include  patch (copy zlib.h header file into qtbase\include) 
REM QTBUG-49522 
set ZLIB_ROOT=..\qtbase\include\QtZlib\
set ZLIB_DEST=..\qtbase\include\
set ZLIB_FILE=zlib.h
if '%ZLIB_INC_PATCH_EN%'=='1' (
   if '%1'=='-u' (
      echo undo zlib inc patch
         if exist "%ZLIB_DEST%%ZLIB_FILE%" (
         del %ZLIB_DEST%%ZLIB_FILE%
      )
   ) else (
      echo applying zlib inc patch
      copy %ZLIB_ROOT%%ZLIB_FILE% %ZLIB_DEST%
   )
)

set VS2015_SUPPORT_PATH=..\qtbase\qmake\generators\win32\
set VS2015_SUPPORT_FILE=cesdkhandler.cpp
if '%VS2015_SUPPORT_PATCH%'=='1' (
   if '%1'=='-u' (
      echo undo VS2015 support patch
      if exist "%VS2015_SUPPORT_PATH%%VS2015_SUPPORT_FILE%%PATCH_EXTENTION%" (
         del %VS2015_SUPPORT_PATH%%VS2015_SUPPORT_FILE%
         rename %VS2015_SUPPORT_PATH%%VS2015_SUPPORT_FILE%%PATCH_EXTENTION% %VS2015_SUPPORT_FILE%
      )
   ) else (
      echo applying VS2015 support patch
      rename %VS2015_SUPPORT_PATH%%VS2015_SUPPORT_FILE% %VS2015_SUPPORT_FILE%%PATCH_EXTENTION%
      copy %VS2015_SUPPORT_FILE% %VS2015_SUPPORT_PATH%
   )
)

REM Copy the GuruCE mkspec for the iMX6 SDK for Visual Studio 2013 and 2015
set MKSPEC_PATH=..\qtbase\mkspecs\
set MKSPEC_FOLDER_2013=wince80GuruCE-armv7-msvc2013
set MKSPEC_FOLDER_2015=wince80GuruCE-armv7-msvc2015
if '%MKSPEC_COPY_EN%'=='1' (
   if '%1'=='-u' (
      echo remove GuruCE mkspec config VS2013
      if exist "%MKSPEC_PATH%%MKSPEC_FOLDER_2013%" (
        rmdir /S /Q %MKSPEC_PATH%%MKSPEC_FOLDER_2013%
      )
      echo remove GuruCE mkspec config VS2015
      if exist "%MKSPEC_PATH%%MKSPEC_FOLDER_2015%" (
        rmdir /S /Q %MKSPEC_PATH%%MKSPEC_FOLDER_2015%
      )
   ) else (
      echo adding GuruCE mkspec config VS2013
      xcopy /I /Y %MKSPEC_FOLDER_2013% %MKSPEC_PATH%%MKSPEC_FOLDER_2013%
      echo adding GuruCE mkspec config VS2015
      xcopy /I /Y %MKSPEC_FOLDER_2015% %MKSPEC_PATH%%MKSPEC_FOLDER_2015%
   )
)

REM Copy qwindowsintegration.cpp to platforms\windows\: fixes qmlscene crashes
set QWINDOWS_INTEGRATION_PATH=..\qtbase\src\plugins\platforms\windows\
set QWINDOWS_INTEGRATION_FILE=qwindowsintegration.cpp
if '%QWINDOWS_INTEGRATION_PATCH%'=='1' (
   if '%1'=='-u' (
      echo undo windows integration patch
      if exist "%QWINDOWS_INTEGRATION_PATH%%QWINDOWS_INTEGRATION_FILE%%PATCH_EXTENTION%" (
         del %QWINDOWS_INTEGRATION_PATH%%QWINDOWS_INTEGRATION_FILE%
         rename %QWINDOWS_INTEGRATION_PATH%%QWINDOWS_INTEGRATION_FILE%%PATCH_EXTENTION% %QWINDOWS_INTEGRATION_FILE%
      )
   ) else (
      echo applying windows integration patch
      rename %QWINDOWS_INTEGRATION_PATH%%QWINDOWS_INTEGRATION_FILE% %QWINDOWS_INTEGRATION_FILE%%PATCH_EXTENTION%
      copy %QWINDOWS_INTEGRATION_FILE% %QWINDOWS_INTEGRATION_PATH%
   )
)

REM 5.6 beta fixes
REM Copy documenthandler.cpp to qtquickcontrols\examples\quick\controls\texteditor\src\: fixes compile error
set QUICKCONTROLS_TEXTEDITOR_PATH=..\qtquickcontrols\examples\quick\controls\texteditor\src\
set QUICKCONTROLS_TEXTEDITOR_FILE=documenthandler.cpp
if '%QUICKCONTROLS_TEXTEDITOR_PATCH%'=='1' (
   if '%1'=='-u' (
      echo undo windows integration patch
      if exist "%QUICKCONTROLS_TEXTEDITOR_PATH%%QUICKCONTROLS_TEXTEDITOR_FILE%%PATCH_EXTENTION%" (
         del %QUICKCONTROLS_TEXTEDITOR_PATH%%QUICKCONTROLS_TEXTEDITOR_FILE%
         rename %QUICKCONTROLS_TEXTEDITOR_PATH%%QUICKCONTROLS_TEXTEDITOR_FILE%%PATCH_EXTENTION% %QUICKCONTROLS_TEXTEDITOR_FILE%
      )
   ) else (
      echo applying windows integration patch
      rename %QUICKCONTROLS_TEXTEDITOR_PATH%%QUICKCONTROLS_TEXTEDITOR_FILE% %QUICKCONTROLS_TEXTEDITOR_FILE%%PATCH_EXTENTION%
      copy %QUICKCONTROLS_TEXTEDITOR_FILE% %QUICKCONTROLS_TEXTEDITOR_PATH%
   )
)

REM DBUS fix. Fix replaces full directories just to make patching simple. DBUS does not compile because the DBUS code tree
REM uses the 'interface' keyword as parameter and method name, which generates compile errors
echo on
set DBUS_BASE_PATH=..\qtbase\src\
set DBUS_BASE_FOLDER=dbus
set DBUS_TOOLS_PATH=..\qttools\src\
set DBUS_TOOLS_FOLDER=qdbus
if '%DBUS_PATCH_EN%'=='1' (
   if '%1'=='-u' (
      echo undo dbus patch
      if exist "%DBUS_BASE_PATH%%DBUS_BASE_FOLDER%%PATCH_EXTENTION%" (
        rmdir /S /Q %DBUS_BASE_PATH%%DBUS_BASE_FOLDER%
        rename %DBUS_BASE_PATH%%DBUS_BASE_FOLDER%%PATCH_EXTENTION% %DBUS_BASE_FOLDER%
      )
      if exist "%DBUS_TOOLS_PATH%%DBUS_TOOLS_FOLDER%%PATCH_EXTENTION%" (
        rmdir /S /Q %DBUS_TOOLS_PATH%%DBUS_TOOLS_FOLDER%
        rename %DBUS_TOOLS_PATH%%DBUS_TOOLS_FOLDER%%PATCH_EXTENTION% %DBUS_TOOLS_FOLDER%
      )
   ) else (
      echo applying dbus patch
      rename %DBUS_BASE_PATH%%DBUS_BASE_FOLDER% %DBUS_BASE_FOLDER%%PATCH_EXTENTION%
      xcopy /I /Y /E %DBUS_BASE_FOLDER% %DBUS_BASE_PATH%%DBUS_BASE_FOLDER%
      rename %DBUS_TOOLS_PATH%%DBUS_TOOLS_FOLDER% %DBUS_TOOLS_FOLDER%%PATCH_EXTENTION%
      xcopy /I /Y /E %DBUS_TOOLS_FOLDER% %DBUS_TOOLS_PATH%%DBUS_TOOLS_FOLDER%
   )
)     
